package com.ether.dao;

import com.ether.IsotopeG03;
import com.ether.Pair;
import com.ether.PersistenceException;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;
import java.util.Set;

/**
 * @author npipsl
 * @date july 2012
 */
public interface IsotopeG03DAO
        extends DomainAccessObject<IsotopeG03, Integer>
{
//    @Nullable
//    Plateform getPlateformById( @NotNull final Integer plateformId ) throws PersistenceException;

    @NotNull
    List<IsotopeG03> getAllIsotopeG03() throws PersistenceException;

    @NotNull
    List<IsotopeG03> getTransitionsByIsotopeG03Name( final List<String> isotopeNameArray, final Float spectralRangeLower, final Float spectralRangeUpper)
            throws PersistenceException;

    @NotNull
    List<IsotopeG03> getTransitionsByIsotopeG03NameByTransitionLower( final String isotopeName, final Float spectralRangeLower, final Float spectralRangeUpper, final String transitionLower)
            throws PersistenceException;

    @NotNull
    List<Pair> getTransitionsLU( final List<String> isotopeNameArray,final Float spectralRangeLower, final Float spectralRangeUpper )
            throws PersistenceException;

    @NotNull
    Set<String> getTransitionsLower(final List<String> isotopesSelectedNameList,final Float spectralRangeLower, final Float spectralRangeUpper )
            throws PersistenceException;

    @NotNull
    Set<String> getTransitionsUpper(final List<String> isotopesSelectedNameList,final Float spectralRangeLower, final Float spectralRangeUpper )
            throws PersistenceException;
}